;----------------------------------------------------------------- -*- lisp -*-
; xemacsen.el -- Convenience utilities used during rpm build
;
; Author: Sergey Bolshakov <sbolshakov@altlinux.ru>
; Created: Thu Jan  6 03:48:26 EET 2005
; Modified: $Date: 2005/01/11 11:48:32 $
; Version: $Id: xemacsen.el,v 1.1 2005/01/11 11:48:32 me Exp $
;
; This file is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2, or (at your option)
; any later version.
;
; This file is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this file.  If not, write to the Free Software
; Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
;------------------------------------------------------------------------------

(defun xemacsen-package-name-to-rpm-name (name)
  "Converts xemacs package name to rpm package name"
  (cond ((eq name 'xemacs-base) 'xemacs-base)
	((eq name 'xemacs-devel) 'xemacs-el-devel)
	(t (make-symbol (format "xemacs-%s" name)))))

(defun xemacsen-get-rpm-requires (name)
  "Outputs required packages for given PACKAGE, in rpm tag format."

  (setq allow-remote-paths nil)
  (package-get-update-base "/usr/share/xemacs/package-index")

  (let ((names (mapcar 'xemacsen-package-name-to-rpm-name
		       (delete name (package-get-info name 'requires)))))
    (when names
      (princ
       (format "Requires: %s"
	       (mapconcat 'symbol-name (sort names 'string<) " "))))))

(defun xemacsen-get-rpm-provides (name)
  "Outputs provides for given PACKAGE, in rpm tag format."

  (setq allow-remote-paths nil)
  (package-get-update-base "/usr/share/xemacs/package-index")

  (let ((names (package-get-info name 'provides)))
    (when names
      (princ
       (mapconcat
	(function (lambda (p) (format "Provides: xemacs(%s)" p)))
	(sort names 'string<) "\n")))))
